#include <IRremote.h>      //must copy IRremote library to arduino libraries
#include <Servo.h>
#define plus 0xA3C8EDDB   //clockwise rotation button
#define minus 0xF076C13B  //counterclockwise rotation button
#define one 0x9716BE3F    //Rotate to left
#define two 0x3D9AE3F7    //Rotate to center
#define three 0x6182021B  //Rotate to right

int RECV_PIN = 3;       //IR receiver pin
Servo servo;
int val;                //rotation angle
bool cwRotation, ccwRotation;  //the states of rotation
IRrecv irrecv(RECV_PIN);
decode_results results; //decodes remote input
int right = 0; int left = 180; int center = 90; //defines servo positions

void setup()
{
  Serial.begin(9600);
  irrecv.enableIRIn(); // Start the receiver
  servo.attach(2);     //servo pin
}

void loop() //main loop
{
  if (irrecv.decode(&results)) {
    Serial.println(results.value, HEX);
    irrecv.resume(); // Receive the next value

  if (results.value == plus)
    {
      cwRotation = !cwRotation;      //toggle the rotation value

      ccwRotation = false;         //no rotation in this direction
      delay(100);
    }

  if (results.value == minus)
    {
      ccwRotation = !ccwRotation;   //toggle the rotation value
      cwRotation = false;            //no rotation in this direction
      delay(100);
    }
    
  if (results.value == one)
    {
      servo.write(left);          //rotates to the left
      delay(100);
  }
    
  if (results.value == two)
    {
      servo.write(center);          //rotates to the center
      delay(100);
  }
  
  if (results.value == three)
  {
      servo.write(right);          //rotates to the right
      delay(100);

  }
  }

  if (cwRotation && (val != 175))  {
    val++;                         //for clockwise button, slowly sweeps clockwise
    servo.write(val);
     delay(100);
  }

  if (ccwRotation && (val != 0))  {
    val--;                         //for counter clockwise button, slowly sweeps counterclockwise
  servo.write(val);
   delay(100);//General speed
  }
         

  }
      
